ElfReloaded = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0","AceEvent-2.0", "AceHook-2.1")

function ElfReloaded:OnInitialize()
end


function ElfReloaded:OnDisable()
end
local options = {
		type = "group",
		args = {
			lock = {
				type = "execute",
				name = "lock",
				desc = "Lock the frames",
				func = "LockFrames",
				},
			unlock = {
				type = "execute",
				name = "unlock",
				desc = "Unlock the frames",
				func = "UnlockFrames",
				},
			},
		}
		
ElfReloaded:RegisterChatCommand({"/elf","/ElfReloaded"},options)

local numFrames = 4
local idTable = {}

function ElfReloaded:OnEnable()
	self:Hook("GroupLootFrame_OpenNewFrame","OpenNewFrame", true)
	self:RegisterEvent("CHAT_MSG_LOOT")
	for i = 1, numFrames do getglobal("ElfReloaded_MoverFrame"..i.."Name"):SetText("Drag Frame"..i) end
	end

function ElfReloaded:CHAT_MSG_LOOT()
	local itemName, choice = self:ParseChat(arg1)
	if itemName and choice and idTable[itemName] then 
		local i = 1
		while getglobal("ElfReloaded_GroupLootFrame"..i) do
			if getglobal("ElfReloaded_GroupLootFrame"..i).rollID == idTable[itemName] then
				if choice == 1 then
					local s = getglobal("ElfReloaded_GroupLootFrame"..i.."Need"):GetText()
					getglobal("ElfReloaded_GroupLootFrame"..i.."Need"):SetText("Need: "..tonumber(string.sub(s,7, string.len(s))) +1)
					return
				elseif choice == 2 then
					local s = getglobal("ElfReloaded_GroupLootFrame"..i.."Greed"):GetText()
					getglobal("ElfReloaded_GroupLootFrame"..i.."Greed"):SetText("Greed: "..tonumber(string.sub(s,8, string.len(s))) +1)
					return
				elseif choice == 0 then
					local s = getglobal("ElfReloaded_GroupLootFrame"..i.."Pass"):GetText()
					getglobal("ElfReloaded_GroupLootFrame"..i.."Pass"):SetText("Pass: "..tonumber(string.sub(s,7, string.len(s))) +1)
					return
				end
			end
			i = i + 1
		end
	end
end

function ElfReloaded:ParseChat(msg)
	for item, name in string.gmatch(msg, "|Hitem:(%d+:%d+:%d+:%d+)|h%[(.-)%]|h") do
		if string.find(msg,"passed on:") then if name then return name, 0 end end
		if string.find(msg,"selected Greed for:") then if name then return name, 2 end end
		if string.find(msg,"selected Need for:") then if name then return name, 1 end end
	end
end

function ElfReloaded:LockFrames()
	for i = 1, numFrames do getglobal("ElfReloaded_MoverFrame"..i):Hide() end
end

function ElfReloaded:UnlockFrames()
	for i = 1, numFrames do getglobal("ElfReloaded_MoverFrame"..i):Show() end
end

function ElfReloaded:OpenNewFrame(id)
	for i=1, numFrames do
		local f = getglobal("ElfReloaded_GroupLootFrame"..i)
		if not f:IsVisible() then
			f.rollID = id
			f:Show()
			return
		end
	end
end

function ElfReloaded:FrameOnShow()
	local texture, name, _, quality = GetLootRollItemInfo(this.rollID)
	if name then idTable[name] = this.rollID end
	getglobal(this:GetName().."IconFrameIcon"):SetTexture(texture)
	getglobal(this:GetName().."Name"):SetText(name)
	getglobal(this:GetName().."Need"):SetText("Need: 0")
	getglobal(this:GetName().."Greed"):SetText("Greed: 0")
	getglobal(this:GetName().."Pass"):SetText("Pass : 0")
	local color = ITEM_QUALITY_COLORS[quality]
	getglobal(this:GetName()):SetBackdropColor(color.r,color.g,color.b,0.7)
	getglobal(this:GetName()):SetBackdropBorderColor(color.r,color.g,color.b, 1)
end